<template>
  <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100 base-datatable">
    <md-table style="margin: 0px 20px;">
      <md-table-toolbar>
        <div class="md-toolbar-section-start">
          <h1 class="md-title">ICO Settings</h1>
        </div>
      </md-table-toolbar>

      <md-table-row>
        <md-table-head>#</md-table-head>
        <md-table-head>Name</md-table-head>
        <md-table-head>Value</md-table-head>
        <md-table-head></md-table-head>
      </md-table-row>

      <md-table-row>
        <md-table-cell>1</md-table-cell>
        <md-table-cell>Start time</md-table-cell>
        <md-table-cell>
          <md-field :class="{'md-invalid': errors.has('ico_start_time')}">
            <datetime-picker input-type="timestamp"
                             data-vv-as="start time"
                             v-validate="'required'"
                             name="ico_start_time"
                             :max-datetime="icoSettings.ico_end_time"
                             v-model="icoSettings.ico_start_time"
                             format="yyyy-MM-dd HH:mm:ss">
            </datetime-picker>
            <span class="md-error" v-if="errors.has('ico_start_time')">{{ errors.first('ico_start_time') }}</span>
          </md-field>
        </md-table-cell>
        <md-table-cell>
          <md-button class="md-raised md-button-primary" @click="showConfirmDialog('ico_start_time', icoSettings.ico_start_time)">Save
          </md-button>
        </md-table-cell>
      </md-table-row>

      <md-table-row>
        <md-table-cell>2</md-table-cell>
        <md-table-cell>End time</md-table-cell>
        <md-table-cell>
          <md-field :class="{'md-invalid': errors.has('ico_end_time')}">
            <datetime-picker input-type="timestamp"
                             data-vv-as="end time"
                             v-validate="'required'"
                             name="ico_end_time"
                             :min-datetime="icoSettings.ico_start_time"
                             v-model="icoSettings.ico_end_time"
                             format="yyyy-MM-dd HH:mm:ss">
            </datetime-picker>
            <span class="md-error" v-if="errors.has('ico_end_time')">{{ errors.first('ico_end_time') }}</span>
          </md-field>
        </md-table-cell>
        <md-table-cell>
          <md-button class="md-raised md-button-primary" @click="showConfirmDialog('ico_end_time', icoSettings.ico_end_time)">Save
          </md-button>
        </md-table-cell>
      </md-table-row>

      <md-table-row>
        <md-table-cell>3</md-table-cell>
        <md-table-cell>Price of HETA Token per USD</md-table-cell>
        <md-table-cell>
          <md-field :class="{'md-invalid': errors.has('ico_price_heta_token_per_usd')}">
            <md-input
              name="ico_price_heta_token_per_usd"
              data-vv-as="price heta token per usd"
              v-model="icoSettings.ico_price_heta_token_per_usd"
              v-validate="'required|min_value:0|decimal:18'"
              data-vv-validate-on="none"
              type="number"></md-input>
            <span class="md-error"
                  v-if="errors.has('ico_price_heta_token_per_usd')">
                  {{ errors.first('ico_price_heta_token_per_usd') }}
                </span>
          </md-field>
        </md-table-cell>
        <md-table-cell>
          <md-button class="md-raised md-button-primary"
                     @click="showConfirmDialog('ico_price_heta_token_per_usd', icoSettings.ico_price_heta_token_per_usd)">Save
          </md-button>
        </md-table-cell>
      </md-table-row>

      <md-table-row>
        <md-table-cell>4</md-table-cell>
        <md-table-cell>Hardcap by USD</md-table-cell>
        <md-table-cell>
          <md-field :class="{'md-invalid': errors.has('ico_hardcap_by_usd')}">
            <md-input
              name="ico_hardcap_by_usd"
              data-vv-as="hardcap by usd"
              v-model="icoSettings.ico_hardcap_by_usd"
              v-validate="'required|min_value:0|decimal:18'"
              data-vv-validate-on="none"
              type="number"></md-input>
            <span class="md-error"
                  v-if="errors.has('ico_hardcap_by_usd')">{{ errors.first('ico_hardcap_by_usd') }}</span>
          </md-field>
        </md-table-cell>
        <md-table-cell>
          <md-button class="md-raised md-button-primary" @click="showConfirmDialog('ico_hardcap_by_usd', icoSettings.ico_hardcap_by_usd)">
            Save
          </md-button>
        </md-table-cell>
      </md-table-row>

    </md-table>
    <md-dialog-confirm
      :md-active.sync="isShowConfirmDialog"
      md-title="Are you sure you want to update?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelUpdate"
      @md-confirm="onConfirmUpdate"/>
  </div>
</template>

<script>
  import rf from '../../common/requests/RequestFactory';
  import DatetimePicker from '../components/DatetimePicker.vue';

  export default {
    components: {
      DatetimePicker
    },
    data () {
      return {
        icoSettings: [],
        isShowConfirmDialog: false,
        icosettingWillUpdate: {},
      }
    },
    methods: {
      showConfirmDialog (key, setting) {
        this.$validator.validate(key)
          .then((result) => {
            if (!result) {
              return;
            }
            this.isShowConfirmDialog = true;
            this.icosettingWillUpdate = {key: key, value: setting};
          });
      },

      onConfirmUpdate () {
        this.updateSetting(this.icosettingWillUpdate);
        this.icosettingWillUpdate = {};
        this.$toasted.show('You updated successfully!', {
          theme: 'bubble',
          position: 'top-right',
          duration: 2000
        });
      },

      getSystemSettings () {
        rf.getRequest('SystemSettingRequest').getAll().then(res => {
          this.icoSettings = res.data;
        });
      },

      onCancelUpdate () {
        this.settingWillUpdate = {};
        this.getSystemSettings();
      },

      updateSetting (setting) {
        this.$validator.validate(setting.key)
          .then((result) => {
            if (!result) {
              return;
            }

            rf.getRequest('SystemSettingRequest').updateSetting(setting).then(res => {
              this.getSystemSettings();
            });
          });
      }
    },
    mounted () {
      this.getSystemSettings();
    }
  }
</script>

<style lang="scss" scoped>
  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }
</style>
